(function ($) {
  // Store our function as a property of Drupal.behaviors.
  Drupal.behaviors.highwire_shareitajax = { attach: function (context, settings) {
    
    var getWidth = function() {
      var winWidth = $(window).width();
      if(winWidth >= Drupal.settings.highwire.share_modal_width) {
        return Drupal.settings.highwire.share_modal_width;
      } else {
        return "90%";
      }
    }
    
    var success = false;
    var id ='';
    var encodedUrl = '';
    $('.highwire_clipboard_link_ajax', context, settings).click(function(){
      id = $(this).attr('id');
      $(this).parent().find('.highwire_clipboard_form_ajax_'+id).dialog({"modal":true, "draggable":false, "width":getWidth(), "title":'Share this Article', "resizable":false});
      $('.highwire_clipboard_form_ajax_'+id).dialog('open');
      $("a#copy-dynamic").zclip({
        path: '/' + Drupal.settings.highwire.moviepath,
        copy: function() { return $("input#dynamic").val(); }
      });
      return false;
    });
  }};
}(jQuery));
;
/*
 * zClip :: jQuery ZeroClipboard v1.1.1
 * http://steamdev.com/zclip
 *
 * Copyright 2011, SteamDev
 * Released under the MIT license.
 * http://www.opensource.org/licenses/mit-license.php
 *
 * Date: Wed Jun 01, 2011
 */


(function ($) {

    $.fn.zclip = function (params) {

        if (typeof params == "object" && !params.length) {

            var settings = $.extend({

                path: 'ZeroClipboard.swf',
                copy: null,
                beforeCopy: null,
                afterCopy: null,
                clickAfter: true,
                setHandCursor: true,
                setCSSEffects: true

            }, params);
			

            return this.each(function () {

                var o = $(this);

                if (o.is(':visible') && (typeof settings.copy == 'string' || $.isFunction(settings.copy))) {

                    ZeroClipboard.setMoviePath(settings.path);
                    var clip = new ZeroClipboard.Client();
                    
                    if($.isFunction(settings.copy)){
                    	o.bind('zClip_copy',settings.copy);
                    }
                    if($.isFunction(settings.beforeCopy)){
                    	o.bind('zClip_beforeCopy',settings.beforeCopy);
                    }
                    if($.isFunction(settings.afterCopy)){
                    	o.bind('zClip_afterCopy',settings.afterCopy);
                    }                    

                    clip.setHandCursor(settings.setHandCursor);
                    clip.setCSSEffects(settings.setCSSEffects);
                    clip.addEventListener('mouseOver', function (client) {
                        o.trigger('mouseenter');
                    });
                    clip.addEventListener('mouseOut', function (client) {
                        o.trigger('mouseleave');
                    });
                    clip.addEventListener('mouseDown', function (client) {

                        o.trigger('mousedown');
                        
			if(!$.isFunction(settings.copy)){
			   clip.setText(settings.copy);
			} else {
			   clip.setText(o.triggerHandler('zClip_copy'));
			}                        
                        
                        if ($.isFunction(settings.beforeCopy)) {
                            o.trigger('zClip_beforeCopy');                            
                        }

                    });

                    clip.addEventListener('complete', function (client, text) {

                        if ($.isFunction(settings.afterCopy)) {
                            
                            o.trigger('zClip_afterCopy');

                        } else {
                            if (text.length > 500) {
                                text = text.substr(0, 500) + "...\n\n(" + (text.length - 500) + " characters not shown)";
                            }
							
			    o.removeClass('hover');
                            
                        }

                        if (settings.clickAfter) {
                            o.trigger('click');
                        }

                    });

					
                    clip.glue(o[0], o.parent()[0]);
					
		    $(window).bind('load resize',function(){clip.reposition();});
					

                }

            });

        } else if (typeof params == "string") {

            return this.each(function () {

                var o = $(this);

                params = params.toLowerCase();
                var zclipId = o.data('zclipId');
                var clipElm = $('#' + zclipId + '.zclip');

                if (params == "remove") {

                    clipElm.remove();
                    o.removeClass('active hover');

                } else if (params == "hide") {

                    clipElm.hide();
                    o.removeClass('active hover');

                } else if (params == "show") {

                    clipElm.show();

                }

            });

        }

    }



})(jQuery);







// ZeroClipboard
// Simple Set Clipboard System
// Author: Joseph Huckaby
var ZeroClipboard = {

    version: "1.0.7",
    clients: {},
    // registered upload clients on page, indexed by id
    moviePath: 'ZeroClipboard.swf',
    // URL to movie
    nextId: 1,
    // ID of next movie
    $: function (thingy) {
        // simple DOM lookup utility function
        if (typeof(thingy) == 'string') thingy = document.getElementById(thingy);
        if (!thingy.addClass) {
            // extend element with a few useful methods
            thingy.hide = function () {
                this.style.display = 'none';
            };
            thingy.show = function () {
                this.style.display = '';
            };
            thingy.addClass = function (name) {
                this.removeClass(name);
                this.className += ' ' + name;
            };
            thingy.removeClass = function (name) {
                var classes = this.className.split(/\s+/);
                var idx = -1;
                for (var k = 0; k < classes.length; k++) {
                    if (classes[k] == name) {
                        idx = k;
                        k = classes.length;
                    }
                }
                if (idx > -1) {
                    classes.splice(idx, 1);
                    this.className = classes.join(' ');
                }
                return this;
            };
            thingy.hasClass = function (name) {
                return !!this.className.match(new RegExp("\\s*" + name + "\\s*"));
            };
        }
        return thingy;
    },

    setMoviePath: function (path) {
        // set path to ZeroClipboard.swf
        this.moviePath = path;
    },

    dispatch: function (id, eventName, args) {
        // receive event from flash movie, send to client		
        var client = this.clients[id];
        if (client) {
            client.receiveEvent(eventName, args);
        }
    },

    register: function (id, client) {
        // register new client to receive events
        this.clients[id] = client;
    },

    getDOMObjectPosition: function (obj, stopObj) {
        // get absolute coordinates for dom element
        var info = {
            left: 0,
            top: 0,
            width: obj.width ? obj.width : obj.offsetWidth,
            height: obj.height ? obj.height : obj.offsetHeight
        };

        if (obj && (obj != stopObj)) {
			info.left += obj.offsetLeft;
            info.top += obj.offsetTop;
        }

        return info;
    },

    Client: function (elem) {
        // constructor for new simple upload client
        this.handlers = {};

        // unique ID
        this.id = ZeroClipboard.nextId++;
        this.movieId = 'ZeroClipboardMovie_' + this.id;

        // register client with singleton to receive flash events
        ZeroClipboard.register(this.id, this);

        // create movie
        if (elem) this.glue(elem);
    }
};

ZeroClipboard.Client.prototype = {

    id: 0,
    // unique ID for us
    ready: false,
    // whether movie is ready to receive events or not
    movie: null,
    // reference to movie object
    clipText: '',
    // text to copy to clipboard
    handCursorEnabled: true,
    // whether to show hand cursor, or default pointer cursor
    cssEffects: true,
    // enable CSS mouse effects on dom container
    handlers: null,
    // user event handlers
    glue: function (elem, appendElem, stylesToAdd) {
        // glue to DOM element
        // elem can be ID or actual DOM element object
        this.domElement = ZeroClipboard.$(elem);

        // float just above object, or zIndex 99 if dom element isn't set
        var zIndex = 99;
        if (this.domElement.style.zIndex) {
            zIndex = parseInt(this.domElement.style.zIndex, 10) + 1;
        }

        if (typeof(appendElem) == 'string') {
            appendElem = ZeroClipboard.$(appendElem);
        } else if (typeof(appendElem) == 'undefined') {
            appendElem = document.getElementsByTagName('body')[0];
        }

        // find X/Y position of domElement
        var box = ZeroClipboard.getDOMObjectPosition(this.domElement, appendElem);

        // create floating DIV above element
        this.div = document.createElement('div');
        this.div.className = "zclip";
        this.div.id = "zclip-" + this.movieId;
        jQuery(this.domElement).data('zclipId', 'zclip-' + this.movieId);
        var style = this.div.style;
        style.position = 'absolute';
        style.left = '' + box.left + 'px';
        style.top = '' + box.top + 'px';
        style.width = '' + box.width + 'px';
        style.height = '' + box.height + 'px';
        style.zIndex = zIndex;

        if (typeof(stylesToAdd) == 'object') {
            for (addedStyle in stylesToAdd) {
                style[addedStyle] = stylesToAdd[addedStyle];
            }
        }

        // style.backgroundColor = '#f00'; // debug
        appendElem.appendChild(this.div);

        this.div.innerHTML = this.getHTML(box.width, box.height);
    },

    getHTML: function (width, height) {
        // return HTML for movie
        var html = '';
        var flashvars = 'id=' + this.id + '&width=' + width + '&height=' + height;

        if (navigator.userAgent.match(/MSIE/)) {
            // IE gets an OBJECT tag
            var protocol = location.href.match(/^https/i) ? 'https://' : 'http://';
            html += '<object classid="clsid:d27cdb6e-ae6d-11cf-96b8-444553540000" codebase="' + protocol + 'download.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=9,0,0,0" width="' + width + '" height="' + height + '" id="' + this.movieId + '" align="middle"><param name="allowScriptAccess" value="always" /><param name="allowFullScreen" value="false" /><param name="movie" value="' + ZeroClipboard.moviePath + '" /><param name="loop" value="false" /><param name="menu" value="false" /><param name="quality" value="best" /><param name="bgcolor" value="#ffffff" /><param name="flashvars" value="' + flashvars + '"/><param name="wmode" value="transparent"/></object>';
        } else {
            // all other browsers get an EMBED tag
            html += '<embed id="' + this.movieId + '" src="' + ZeroClipboard.moviePath + '" loop="false" menu="false" quality="best" bgcolor="#ffffff" width="' + width + '" height="' + height + '" name="' + this.movieId + '" align="middle" allowScriptAccess="always" allowFullScreen="false" type="application/x-shockwave-flash" pluginspage="http://www.macromedia.com/go/getflashplayer" flashvars="' + flashvars + '" wmode="transparent" />';
        }
        return html;
    },

    hide: function () {
        // temporarily hide floater offscreen
        if (this.div) {
            this.div.style.left = '-2000px';
        }
    },

    show: function () {
        // show ourselves after a call to hide()
        this.reposition();
    },

    destroy: function () {
        // destroy control and floater
        if (this.domElement && this.div) {
            this.hide();
            this.div.innerHTML = '';

            var body = document.getElementsByTagName('body')[0];
            try {
                body.removeChild(this.div);
            } catch (e) {;
            }

            this.domElement = null;
            this.div = null;
        }
    },

    reposition: function (elem) {
        // reposition our floating div, optionally to new container
        // warning: container CANNOT change size, only position
        if (elem) {
            this.domElement = ZeroClipboard.$(elem);
            if (!this.domElement) this.hide();
        }

        if (this.domElement && this.div) {
            var box = ZeroClipboard.getDOMObjectPosition(this.domElement);
            var style = this.div.style;
            style.left = '' + box.left + 'px';
            style.top = '' + box.top + 'px';
        }
    },

    setText: function (newText) {
        // set text to be copied to clipboard
        this.clipText = newText;
        if (this.ready) {
            this.movie.setText(newText);
        }
    },

    addEventListener: function (eventName, func) {
        // add user event listener for event
        // event types: load, queueStart, fileStart, fileComplete, queueComplete, progress, error, cancel
        eventName = eventName.toString().toLowerCase().replace(/^on/, '');
        if (!this.handlers[eventName]) {
            this.handlers[eventName] = [];
        }
        this.handlers[eventName].push(func);
    },

    setHandCursor: function (enabled) {
        // enable hand cursor (true), or default arrow cursor (false)
        this.handCursorEnabled = enabled;
        if (this.ready) {
            this.movie.setHandCursor(enabled);
        }
    },

    setCSSEffects: function (enabled) {
        // enable or disable CSS effects on DOM container
        this.cssEffects = !! enabled;
    },

    receiveEvent: function (eventName, args) {
        // receive event from flash
        eventName = eventName.toString().toLowerCase().replace(/^on/, '');

        // special behavior for certain events
        switch (eventName) {
        case 'load':
            // movie claims it is ready, but in IE this isn't always the case...
            // bug fix: Cannot extend EMBED DOM elements in Firefox, must use traditional function
            this.movie = document.getElementById(this.movieId);
            if (!this.movie) {
                var self = this;
                setTimeout(function () {
                    self.receiveEvent('load', null);
                }, 1);
                return;
            }

            // firefox on pc needs a "kick" in order to set these in certain cases
            if (!this.ready && navigator.userAgent.match(/Firefox/) && navigator.userAgent.match(/Windows/)) {
                var self = this;
                setTimeout(function () {
                    self.receiveEvent('load', null);
                }, 100);
                this.ready = true;
                return;
            }

            this.ready = true;
            try {
                this.movie.setText(this.clipText);
            } catch (e) {}
            try {
                this.movie.setHandCursor(this.handCursorEnabled);
            } catch (e) {}
            break;

        case 'mouseover':
            if (this.domElement && this.cssEffects) {
                this.domElement.addClass('hover');
                if (this.recoverActive) {
                    this.domElement.addClass('active');
                }


            }


            break;

        case 'mouseout':
            if (this.domElement && this.cssEffects) {
                this.recoverActive = false;
                if (this.domElement.hasClass('active')) {
                    this.domElement.removeClass('active');
                    this.recoverActive = true;
                }
                this.domElement.removeClass('hover');

            }
            break;

        case 'mousedown':
            if (this.domElement && this.cssEffects) {
                this.domElement.addClass('active');
            }
            break;

        case 'mouseup':
            if (this.domElement && this.cssEffects) {
                this.domElement.removeClass('active');
                this.recoverActive = false;
            }
            break;
        } // switch eventName
        if (this.handlers[eventName]) {
            for (var idx = 0, len = this.handlers[eventName].length; idx < len; idx++) {
                var func = this.handlers[eventName][idx];

                if (typeof(func) == 'function') {
                    // actual function reference
                    func(this, args);
                } else if ((typeof(func) == 'object') && (func.length == 2)) {
                    // PHP style object + method, i.e. [myObject, 'myMethod']
                    func[0][func[1]](this, args);
                } else if (typeof(func) == 'string') {
                    // name of function
                    window[func](this, args);
                }
            } // foreach event handler defined
        } // user defined handler for event
    }

};	

;
(function ($) {

Drupal.behaviors.textarea = {
  attach: function (context, settings) {
    $('.form-textarea-wrapper.resizable', context).once('textarea', function () {
      var staticOffset = null;
      var textarea = $(this).addClass('resizable-textarea').find('textarea');
      var grippie = $('<div class="grippie"></div>').mousedown(startDrag);

      grippie.insertAfter(textarea);

      function startDrag(e) {
        staticOffset = textarea.height() - e.pageY;
        textarea.css('opacity', 0.25);
        $(document).mousemove(performDrag).mouseup(endDrag);
        return false;
      }

      function performDrag(e) {
        textarea.height(Math.max(32, staticOffset + e.pageY) + 'px');
        return false;
      }

      function endDrag(e) {
        $(document).unbind('mousemove', performDrag).unbind('mouseup', endDrag);
        textarea.css('opacity', 1);
      }
    });
  }
};

})(jQuery);
;
(function ($) {
  // Store our function as a property of Drupal.behaviors.
  Drupal.behaviors.highwire_citation_export = { attach: function (context, settings) {
    var success = false;

    $('.highwire-citation-export-link-ajax', context).click(function(){
      $('.highwire-citation-export-link-ajax-popup').dialog({modal:true, draggable:false, maxWidth:700});
      return false;
    });

  }};
}(jQuery));
;
(function ($) {
  // Store our function as a property of Drupal.behaviors.
  Drupal.behaviors.minipanel_dialog_link = { attach: function (context, settings) {

    var getWidth = function() {
      var winWidth = $(window).width();
      if(winWidth >= Drupal.settings.highwire.modal_window_width) {
        return Drupal.settings.highwire.modal_window_width;
      } else {
        return "90%";
      }
    }
    
    $('.minipanel-dialog-link-trigger', context, settings).once('minipanel-dialog-link-trigger', function() {
      if($(this).attr('title') != '<blank>'){
        var title = $(this).attr('title');
      }
      else {
        var title = '';
      }
      var $mini = $(this).parent().parent().find('.minipanel-dialog-link-mini');
      $mini.dialog({"modal":true, "draggable":false, "title": title, "resizable":false, "autoOpen": false});
      $(this).click(function() {
        $mini.dialog({"width":getWidth()});
        $mini.dialog("open");
        return false;
      });
    });
  }};
}(jQuery));
;
/**
 * Highwire Article Nav
 *
 * Copyright (c) 2010-2011 Board of Trustees, Leland Stanford Jr. University
 * This software is open-source licensed under the GNU Public License Version 2 or later
 * The full license is available in the LICENSE.TXT file at the root of this repository
 */

(function ($) {
  Drupal.behaviors.highwire_article_nav = {
    attach: function (context, settings) {
      $('.highwire-article-nav', context).once('highwire-article-nav', function() {
        $wrapper = $(this);

        $('a', $wrapper).click(function() {
          $link = $(this);
          var panelTarget = $link.data('panel-ajax-tab');
          var href = $link.attr('href');

          if (panelTarget) {
            var $tabLink = $('a.panels-ajax-tab-tab[data-panel-name="' + panelTarget + '"]');
            var $tabTargetId = $tabLink.attr('data-target-id');
            // Get Tab container ID to jump no the top of Tab container.
            var $tabContainer = $('#panels-ajax-tab-container-' + $tabTargetId);

            // If we are on the current tab and we are clicking a anchor, just let it happen
            // If we on the current tab and it is not an anchor, then ignore it.
            if ($tabLink.parent().hasClass('active')) {
              if (href.substring(0, 1) === '#') {
                return true;
              }
              else {
                // Jump to the tab, but don't do anything else
                $('html, body').animate({
                  scrollTop: $tabContainer.offset().top + 'px'
                }, 'fast');
                return false;
              }
            }
            // We need to trigger a tab change
            else {
              // If it's a link to the tab itself (and not a sub-component) then just trigger a click on the tab and jump to the tab
              if (href.substring(0, 1) != '#') {
                $tabLink.trigger('click');

                // Jump to the tab
                $('html, body').animate({
                  scrollTop: $tabContainer.offset().top + 'px'
                }, 'fast');
              }
              // We need to trigger the panel-ajax-tab THEN we need to jump to the anchored content
              else {
                $tabLink.panels_ajax_tabs_trigger(function() {
                  $('html, body').animate({
                    scrollTop: $(href).offset().top + 'px'
                  }, 'fast');
                });
              }
              return false;
            }
          }
        });
      });
    }
  };
})(jQuery);
;
/**
 * Highwire Article Nav
 *
 * Copyright (c) 2010-2011 Board of Trustees, Leland Stanford Jr. University
 * This software is open-source licensed under the GNU Public License Version 2 or later
 * The full license is available in the LICENSE.TXT file at the root of this repository
 */

(function ($) {
  Drupal.behaviors.highwireNavFloat = {
    attach: function (context, settings) {

      /**
       * Function to check if the nav pane should be floated.
       */
      var checkNavFloat = function(threshold, threshold_height, this_pane_height, pane_last_offset, y_scroll_pos) {
        var currentLayout = Drupal.highwireResponsive.getCurrentLayout();
        if ((y_scroll_pos < threshold) || (threshold_height < (this_pane_height + y_scroll_pos)) || (currentLayout == 'mobile')) {
          return false;
        }
        else if (y_scroll_pos > pane_last_offset.top) {
          return true;
        }
      }

      /**
       * Position the floated nav pane.
       */
      $.fn.floatNav = function(options) {
        var settings = $.extend({
          topOffset: 20,
          wrapDiv: '<div class="highwire-nav-float-wrapper"></div>',
        }, options);

        this.wrap(settings.wrapDiv);
        this.parent()
          .hide()
          .css('position', 'fixed')
          .css('top', settings.topOffset + 'px')
          .fadeIn('slow');
      }

      $('.highwire-nav-float', context).once('highwire-nav-float', function() {
        var $wrapper = $(this);
        var $list = $('ul, ol', $wrapper);

        // Scrolling float
        if ($list.data('highwire-float') == '1') {
          var wrap_class = $list.data('highwire-float-class');
          var wrapDiv = '<div class="highwire-nav-float-wrapper ' + wrap_class + '"></div>';
          var topOffset = 20;
          var floated = false;

          // Since we are calculating heights of elements below, should be done after all the elements are loaded
          $(window).load(function(e) {
            var $this_pane = $wrapper.parent().parent();
            var $pane_last = $this_pane.siblings().last();
            var pane_last_offset = $pane_last.offset();
            var pane_last_height = $pane_last.height();
            var threshold = parseInt(pane_last_offset.top) + parseInt(pane_last_height);
            var this_pane_height = $this_pane.height();
            var $footer_section = $('#section-footer');
            var y_scroll_pos = window.pageYOffset;
            var threshold_height = $footer_section.offset().top - topOffset;

            // Check if pane should be floated and set its position.
            check_float_result = checkNavFloat(threshold, threshold_height, this_pane_height, pane_last_offset, y_scroll_pos);
            if (check_float_result === false && floated === true) {
              $this_pane.unwrap();
              floated = false;
            }
            else if (check_float_result === true && floated === false) {
              $this_pane.floatNav({topOffset: topOffset, wrapDiv: wrapDiv});
              floated = true;
            }

            $(window).scroll(function(e) {
              y_scroll_pos = window.pageYOffset;
              // JCORE-2464:
              // Recalculate threshold height while scrolling due to lazyloaded images.
              threshold_height = $footer_section.offset().top - topOffset;

              // Check if pane should be floated and set its position.
              check_float_result = checkNavFloat(threshold, threshold_height, this_pane_height, pane_last_offset, y_scroll_pos);
              if (check_float_result === false && floated === true) {
                $this_pane.unwrap();
                floated = false;
              }
              else if (check_float_result === true && floated === false) {
                $this_pane.floatNav({topOffset: topOffset, wrapDiv: wrapDiv});
                floated = true;
              }
            });
          });
        }
      });
    }
  };
})(jQuery);
;
(function ($) {
  Drupal.behaviors.panels_accordion = {
    attach: function (context, settings) {
      $.each(Drupal.settings.panels_accordion, function($index_id, $options){
        $('#' + $index_id).accordion($options);
      });
    }
  };
}(jQuery));

;
/**
 * Highwire Article access indicator
 *
 * Copyright (c) 2010-2011 Board of Trustees, Leland Stanford Jr. University
 * This software is open-source licensed under the GNU Public License Version 2 or later
 * The full license is available in the LICENSE.TXT file at the root of this repository
 */
(function ($) {
  // Store our function as a property of Drupal.behaviors.
  Drupal.behaviors.highwire_access_indicator = {
    attach: function (context, settings) {
      var items = [];

      // The ajax call seems to error intermittently on the first run through.
      // During subsequent times that drupal.behaviors is loaded, the
      // context is no longer the document object, which was causing it to fail
      // the lookup.
      $access_icons = $('span.highwire-citation-access-check, span.highwire-citation-pdf-download');

      $access_icons.each(function() {
        var itemdata = {
          pisa_id: $(this).closest('[data-pisa-id]').data('pisa-id'),
          apath: $(this).closest('[data-apath]').data('apath'),
          view: $(this).data('request-view'),
        };
        items.push(itemdata);
      });
      if (items.length > 0) {
        $.ajax({
          url: '/highwire/articlecitation/ac',
          type: 'POST',
          data: {'items' : items},
          success: function(data) {
            $access_icons.each(function(index){
              var elem = $(this);
              var pisa_id = $(this).closest('[data-pisa-id]').data('pisa-id');
              var apath   = $(this).closest('[data-apath]').data('apath');
              var view = elem.data('request-view');
              // The key can be defined using other elements, but we should
              // always know a pisa_id and a view.
              if (pisa_id) {
                var ac_key = pisa_id + '||' + view;
              }
              else if (apath) {
                 var ac_key = apath + '||' + view;
               }

              if (data[ac_key]['access'][view] != undefined && data[ac_key]['access'][view] == true) {
                if (elem.hasClass('highwire-citation-access-check')) {
                  elem.children('.highwire-access-icon-user-access').show();
                  elem.children('.highwire-access-icon-no-access').hide();
                }
                else if (elem.hasClass('highwire-citation-pdf-download')) {
                  elem.show();
                }
              }
              else {
                elem.children('.highwire-access-icon-no-access').show();
                elem.children('.highwire-access-icon-user-access').hide();
              }
            });
          },
        });
      }
    }
  };
}(jQuery));
;
/**
 * Highwire Author pop up
 *
 * Copyright (c) 2010-2011 Board of Trustees, Leland Stanford Jr. University
 * This software is open-source licensed under the GNU Public License Version 2 or later
 * The full license is available in the LICENSE.TXT file at the root of this repository
 */
(function ($) {
  Drupal.behaviors.articleAuthorPopup = {
    attach: function(context, settings) {
      // This is a hope-to-be temporary check. This should be loaded together with Cluetip lib. The only known
      // issue can be when markup_cache_object from php caches the wrong JS items. However there is no known way of
      // reproducing it.
      var isCluetipExist = !!jQuery.fn.cluetip;
      if (!isCluetipExist) {
        if (window.console) {
          console.error('HW\'s Cluetip behavior is called without the Cluetip library loaded. Please investigate.');
        }
        return;
      }
      
      // JCORE-2366: Add event delegation wrapper around cluetip
      $("body", context).delegate(".has-author-tooltip span.highwire-citation-author:not(.hasTooltip)", "mouseenter", function (event) {
        var elem = $(this);
        var delta = elem.data('delta');
        var parent = elem.parents('.highwire-article-citation');
        var parentId = parent.attr('id');
        var tooltipElem = "#hw-article-author-popups-" + parentId + " .author-tooltip-" + delta;
        
        if ($(tooltipElem).length > 0) {
          elem.addClass('has-tooltip');
          elem.attr('rel', tooltipElem).cluetip({
            onActivate: function(event) {
              // Disable for mobile
              var activate = true;
              if (Drupal.highwireResponsive) {
                var currentLayout = Drupal.highwireResponsive.getCurrentLayout();
                activate = currentLayout !== 'mobile' ? true : false;
              }
              return activate;
            },
            local: true,
            showTitle: false,
            hideLocal: true,
            sticky: true,
            positionBy: 'topBottom',
            mouseOutClose: 'both',
            closePosition: 'none',
            dropShadow: false,
            arrows: true,
            topOffset: 25,
            cluetipClass: 'article-author-popup'
          }).addClass("hasTooltip").trigger("mouseenter");
          event.preventDefault();
        }
      });
    }
  };
})(jQuery);
;
